/*
    menu - justify
*/
import $ from '../../util/dom-core.js';
import DropList from '../droplist.js';
import {getParentByClassname} from '../../util/util.js';
import Jquery from 'jquery';

// 构造函数
function Lineheight(editor) {
    this.editor = editor
    this.$elem = $('<div class="lsiten-e-menu"><i class="lsiten-e-icon-text-heigh"></i></div>')
    this.type = 'droplist'

    // 当前是否 active 状态
    this._active = false

    // 初始化 droplist
    this.droplist = new DropList(this, {
        width: 100,
        $title: $('<p>行高</p>'),
        type: 'list', // droplist 以列表形式展示
        list: [
            { $elem: $('<span>18px</span>'), value: '18' },
            { $elem: $('<span>20px</span>'), value: '20' },
            { $elem: $('<span>25px</span>'), value: '25' },
            { $elem: $('<span>30px</span>'), value: '30' },
            { $elem: $('<span>38px</span>'), value: '38' },
            { $elem: $('<span>44px</span>'), value: '44' },
            { $elem: $('<span>50px</span>'), value: '50' }
        ],
        onClick: (value) => {
          // 注意 this 是指向当前的 List 对象
          value = parseInt(value);
          if (!value) {
              return '';
          }
          let pagemanage = this.editor.page;
          let $currentLine = pagemanage.editorPosition.currentLine;
          let $textElem = pagemanage.$el;
          if (!$currentLine) {
            console.log("%c请在框内操作！", "color:red");
            return '';
          }
          let $border = getParentByClassname($currentLine, 'js-lsiten-border');
          if (!$border) {
            console.log("%c请在框内添操作！", "color:red");
            return '';
          }
          let lineheightValue = value;
          $border.attr('data-blineheight', lineheightValue);
          $border.find('.js-lsiten-line').css('line-height', lineheightValue + 'px');
          Jquery($textElem[0]).trigger('addContent', () => {
            Jquery($textElem[0]).trigger('removeContent');
          });
        }
    })
}

// 原型
Lineheight.prototype = {
    constructor: Lineheight,

    // 执行命令
    _command: function (value) {
        const editor = this.editor
        editor.cmd.do(value)
    }
}

export default Lineheight