/*
    undo-menu
*/
import $ from '../../util/dom-core.js'

// 构造函数
function Undo(editor) {
    this.editor = editor
    this.$elem = $(
        `<div class="lsiten-e-menu">
            <i class="lsiten-e-icon-undo"></i>
        </div>`
    )
    this.type = 'click'

    // 当前是否 active 状态
    this._active = false
}

// 原型
Undo.prototype = {
    constructor: Undo,

    // 点击事件
    onClick: function (e) {
        // 点击菜单将触发这里

        const undoManager = this.editor.page.undoManager;

        // 执行 redo 命令
        undoManager.undo();
        this.editor.selection.saveRange();
    }
}

export default Undo