/**
 * function 数组去重复
 * @param {Array} arr 去重的数组
 */
function uniqueArray(arr){
  let x = new Set(arr);
 return [...x];
}

/**
 * function 根据小问id获取小问数据
 * @param {int} id 排序序号 
 * @param {Array} data  小题数据
 */
function getQuestionsDataById (id, data) {
  return data.filter(item => parseInt(item.quId) === id);
}
/**
 * function 根据小题id获取小题框数据
 * @param {int} id 排序序号 
 * @param {Array} data  小题数据
 */
function getProblemDataById (id, data) {
  return data.filter(item => parseInt(item.proId) === id);
}

/**
 * function 根据框的sort获取框数据
 * @param {int} sort 排序序号 
 * @param {Array} data  框数据
 */
function getBorderDataBySort (sort, data) {
  return data.filter(item => parseInt(item.sort) === sort);
}

/**
 * 
 * @param {int} pageIndex  页面index
 * @param {Node} border 框node
 * @param {int} sort 排序序号 
 * @param {Array} data 框数据
 * @param {Object} borderStart 框编号开始数据
 */
function updateQuestionPosition (pageIndex, border, sort, data, borderStart) {
  let borderData = getBorderDataBySort(sort, data);
  if (borderData[0]) {
    let columns = border.getElementsByClassName('js-option-column');
    if (columns) {
      let columnLength = columns.length;
      let lastColumnIndex = columnLength - 1;
      for (let i = 0; i < columnLength; i++) {
        let column = columns[i]
        let columnIndex = parseInt(column.getAttribute('data-index'));
        let sort = parseInt(column.getAttribute('data-sort'));
        if (borderStart[sort]) {
          columnIndex = borderStart[sort] + i + 1;
        }
        if (i === lastColumnIndex) {
          borderStart[sort] = columnIndex;
        }


        let questions = column.getElementsByClassName('js-lsiten-question');
        if (questions) {
          let questionLength = questions.length;
          let lastquestionIndex = columnLength - 1;
          for (let j = 0; j < questionLength; j++) {
            let questionDom = questions[j];
            let pid = parseInt(questionDom.getAttribute('data-pid'));
            let qid = parseInt(questionDom.getAttribute('data-qid'));
            let problemData = getProblemDataById(pid, borderData[0].pros);
            if (problemData[0]) {
              let questionsData = problemData[0].qus;
              let questionData = getQuestionsDataById(qid, questionsData);
              questionData[0].rIndex = (pageIndex + 1) + '-' + columnIndex;
            } else {
              console.log("%c小问丢失", "color:red")
            }
          }
        } else {
          console.log("%c题丢失", "color:red");
        }
      }
    }
  } else {
    console.log("%c框丢失", "color:red");
  }
}

let borderData = function () {
  let editor = this.editor;
  let pages = editor.page.pages;
  let data = editor.data;
  let borderData = data.pageQus;
  let BorderPages = {};
  let borderStart = {};
  pages.forEach(page => {
    let borders = page.$textElem.find('.js-lsiten-border');
    borders.forEach(border => {
      let type = parseInt(border.getAttribute('data-type'));
      let sort = parseInt(border.getAttribute('data-sort'));
      if (!BorderPages[sort]) {
        BorderPages[sort] = [];
      }
      if (type === 1) {
        updateQuestionPosition(page.pageIndex, border, sort, borderData, borderStart);
      }
      BorderPages[sort].push((page.pageIndex + 1));
    })
  });

  borderData.forEach(border => {
    border.pIndex = uniqueArray(BorderPages[parseInt(border.sort)]).join('-');
  });

  data.examPageCnt = pages.length;
  return data;
}
export default {
  _borderData: borderData
}