import $ from '../util/dom-core.js';
import { getParentByClassname, isEmptyElement } from '../util/util.js';
import { gennerOneLine, gennerOneLines } from '../util/lineUtil.js';
import uuid from 'uuid';

/**
 * function 生成主观题区
* @param {DomElement} $border 需要添加题的框
* @param {JSON} data  题目数据
* @param {Objec} editor 编辑器对象
 */
let generateSubjectBox = function ($border, data, editor) {
  let type = parseInt($border.attr('data-type'));
  if (type === 1) {
    editor.message.showMessage('请在主观题框中添加主观题！');
    return '';
  }

  let mergePnum = data.proData.pnum;
  let pnum = data.pnum;

  if (mergePnum && mergePnum.length > 0) {
    pnum = mergePnum +''+ pnum;
  }

  let $box = $('<div class = "lsiten-subject-box js-lsiten-question"></div>');
  $box.attr('data-type', 3);
  // 在主观题内添加
  let $currentLine = editor.page.editorPosition.currentLine;
  if (!$currentLine) {
    console.log("%c请在框内添加该题！", "color:red");
    return '';
  }
  let $borderContent = getParentByClassname($currentLine, 'border-content');
  if (!$borderContent) {
    console.log("%c请在框内添加该题！", "color:red");
    return '';
  }
  let lineHeight = $borderContent.parent()[0].getAttribute('data-blineheight');  
  gennerOneLines(4, $box, pnum, lineHeight);
  let questionBox = getParentByClassname($currentLine, 'js-lsiten-question');
  if (questionBox) {
    $currentLine = parseInt(questionBox.attr('data-type')) > 2 ? questionBox : questionBox.parent();
  }
  $box.attr('data-id', uuid());  
  $box.insertAfter($currentLine);
  if ( isEmptyElement($borderContent[0].firstChild) ) {
    $borderContent[0].removeChild($borderContent[0].firstChild);
  }

  $box[0].firstChild.focus();
  editor.page._updatePositionInfo(null, $($box[0].firstChild));
}

export default {
  generateSubjectBox: generateSubjectBox
}